unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Velthuis.BigDecimals, mp_real, mp_types, mp_base, system.Math;

// https://www.kurims.kyoto-u.ac.jp/~ooura/pi_fft-j.html
// T.Ooura AGM ASY
// pcs: ΂̐x L
// pai: ΂̒l
// mp_arith͉ZɐݒLɒ܂B
procedure pi_mpf(pcs: integer; var pai: mp_float);
var
  SQRT_SQRT_EPSILON, c, b, e, tmp : mp_float;
  npow, n : cardinal;
  a : mp_float;
begin
  mpf_set_default_decprec(pcs + 10);          // w肳ꂽL+ɐݒ
  mpf_init5(SQRT_SQRT_EPSILON, c, b, e, tmp); // ϐ̏
  mpf_init(a);                                // ϐ̏

  mpf_set_int(SQRT_SQRT_EPSILON, 1);          // 1 ݒ
  mpf_set_int(tmp, 2);                        // 2 ݒ
  mpf_expt_int(tmp, pcs shl 0, tmp);          // 2^(pcs >> 0)
  mpf_div(SQRT_SQRT_EPSILON, tmp, SQRT_SQRT_EPSILON);   // 1 / 2^pcs
  mpf_set_dbl(c, 1 / 8);          // 0.125
  mpf_sqrt(c, c);                 // c = sqrt(0.125);
  mpf_set_int(tmp, 3);            // 3
  mpf_mul(tmp, c, a);             // 3 * c
  mpf_add_int(a, 1, a);           // a = 1 + c * 3;
  mpf_sqrt(a, b);                 // b = sqrt(a)
  mpf_set_dbl(e, 5 / 8);          // 0.625
  mpf_sub(b, e, e);               // e = b - 0.625
  mpf_add(b, b, b);               // b = 2 * b
  mpf_sub(e, c, c);               // c = e - c
  mpf_add(a, e, a);               // a = a + e
  npow := 4;
  n := 0;
  repeat
    npow := npow + npow;          // npow = 2 * npow
    mpf_add(a, b, tmp);           // 'e = a + b'
    mpf_div_int(tmp, 2, e);       // e = (a + b) / 2
    mpf_mul(a, b, tmp);           // 'b = a * b'
    mpf_sqrt(tmp, b);             // b = sqrt(a * b)
    mpf_sub(e, b, e);             // e = e - b
    mpf_add(b, b, b);             // b = 2 * b
    mpf_sub(c, e, c);             // c = c - e
    mpf_add(e, b, a);             // a := e + b
    inc(n);
  until mpf_cmp_mag(e, SQRT_SQRT_EPSILON) <= 0;     // while e > SQRT_SQRT_EPSILON
  mpf_mul(e, e, e);
  mpf_div_int(e, 4, e);           // e = e * e / 4
  mpf_add(a, b, a);               // a = a + b
  mpf_mul(c, a, c);               // 'c = a * c
  mpf_sub(c, e, c);               // 'c = a * c - e
  mpf_mul(a, a, a);               // 'a = a * a
  mpf_sub(a, e, a);               // 'a = a * a - e
  mpf_div_int(e, 2, e);           // 'e = e / 2
  mpf_sub(a, e, a);               // 'a = a * a - e - e / 2
  mpf_div(a, c, a);               // 'a = (a * a - e - e / 2)/(a * c - e)
  mpf_div_int(a, npow, a);        // a = (a * a - e - e / 2)/(a * c - e) / npow
  mpf_copy(a, pai);

  mpf_clear(a);                                   // ϐ̉
  mpf_clear5(SQRT_SQRT_EPSILON, c, b, e, tmp);    // ϐ̉

  Form1.Memo1.Lines.Append('T.Ooura mpf n = ' + intTostr(n));
end;

// https://www.kurims.kyoto-u.ac.jp/~ooura/pi_fft-j.html
// T.Ooura AGM ASY
// pcs ΂̐x
// *Bigdecimal gpӓ_
// *eZł̗L̒lɒӂKvłB
// 1 Z L ZB
// 2 Z
//   a ftHg̗LB
//   b ؂ꍇ͊؂ꂽľLB
//   c q̗LftHgl傫āA̗LftHg菬ꍇZs
//     ̏ꍇAqA̗LftHglɐݒ肷KvB
// 3 
//   a ̗LftHgl菬񕪂̈傫ꍇ ̗LƃftHglƂ̕ϒlB
//   b ̗LftHgl̓񕪂̈菬ꍇ ftHgl̓񕪂̈B
//@ c ̗LftHglƓ傫ꍇ ̗LB
//   d LɎw肪ꍇwla,b,c,̃ftHglB
//   e Jl̏ꍇŁA̒l̖Ƀ[܂ޏꍇ́A[̐ɂȂLB
// 4 Z ۂߖB
// 5 ݏ a^n L̗͌L~nB
// 6 _ȉ̃[L a := '2.0000'  <- L 5
// 7 ZAݏŁA_ȉ̒l̖Ƀ[܂ޏꍇ́ARemoveTrailingZeros(n)Ŗ̃[̏
//   ɁAݏ̏ꍇsKvɗL傫Ȃ̂h~܂B
// 8 肪Kvȏꍇ́AۂRoundToPrecision(n)w肪KvB
function big_pi(pcs: integer): Bigdecimal;
var
  n, dpcs, pcsBack : integer;
  rmback : BigDecimal.RoundingMode;
  SQRT_SQRT_EPSILON, c, b, e : BigDecimal;
  npow : Bigdecimal;
  a, one, two, four, five, eight : Bigdecimal;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcs + 10;                                   // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  one := '1';
  one := one.RoundToPrecision(dpcs);                  // one̗Ldpcsɐݒ
  two := '2';
  four := '4';
  five := '5';
  eight := '8';
  SQRT_SQRT_EPSILON := one / BigDecimal.IntPower(two, pcs shl 0); // l
  c := BigDecimal.Sqrt(one / eight, dpcs * 2);
  a := one + c + c + c;
  b := BigDecimal.Sqrt(a, dpcs * 2);
  e := b - five / eight;
  b := b + b;
  c := e - c;
  a := a + e;
  npow := '4';
  n := 0;
  while e > SQRT_SQRT_EPSILON do begin
    npow := npow + npow;
    e := (a + b) / two;                               // ϒl ZLł̊ۂ
    b := a * b;
    b := b.RoundToPrecision(dpcs);                    // pcs +  ۂ
    b := BigDecimal.Sqrt(b, dpcs * 2);                // Lł̊ۂ
    e := e - b;
    b := b + b;
    c := c - e;
    a := e + b;
    inc(n);
  end;
  e := e * e;
  e := e.RoundToPrecision(dpcs);                      // pcs +  ۂ
  e := e / four;                                      // e = e + e / 4
  a := a + b;
  result := (a * a - e - e / two) / (a * c - e) / npow;   // Z̏Ԃɒ
  result := result.RoundToPrecision(pcs);             // w̐xɊۂ

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA

  Form1.Memo1.Lines.Append('T.Ooura Big n = ' + intTostr(n));
end;

// KEXWh̃ASY
// pcs ΂̐x
function pi_big(pcs: integer): Bigdecimal;
var
  a, b, t, x, an, two, one, four, EPSILON : BigDecimal;
  n, dpcs, pcsBack : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcs + 10;                                    // w萸x * 2
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  one := '1';
  one := one.RoundToPrecision(dpcs);
  two := '2';
  EPSILON := one / BigDecimal.IntPower(two, pcs shl 1);   // l
  four := '4';
  a := one;
  b := one / BigDecimal.Sqrt(two, dpcs * 2);
  t := one / four;                                    // Zx
  x := '1';
  n := 0;
  repeat
    an := (a + b) / two;                              // ϒl ZLł̊ۂ
    b := a * b;
    b := b.RoundToPrecision(dpcs);                    // pcs +   ۂ
    b := BigDecimal.Sqrt(b, dpcs * 2);
    t := t - x * (an - a) * (an - a);
    t := t.RoundToPrecision(dpcs);                    // pcs +   ۂ
    x := x + x;
    a := an;
    inc(n);
  until (BigDecimal.abs(a - b) < EPSILON) or (n > 100);   // n>100̓fobOp
  a := a + b;
  result := a * (a / (four * t));
  result := result.RoundToPrecision(pcs);             // w̐xɊۂ

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA

  Form1.Memo1.Lines.Append('KEXWh Big n = ' + intTostr(n));
end;

// KEXWh̃ASY
function pi_calc: double;
var
  a, b, t, x, an: double;
  n : integer;
  EPSILON : double;
begin
  EPSILON := 1 / power(2, 17);                  // l̐ݒ 17

  a := 1;
  b := 1 / sqrt(2);
  t := 1 / 4;
  x := 1;
  n := 0;
  repeat
    an := (a + b) / 2;                          // ϒl
    b := sqrt(a * b);
    t := t - x * (an - a) * (an - a);
    x := x * 2;
    a := an;
    inc(n);
  until (abs(a - b) < EPSILON) or (n > 100);    // n>100̓fobOp
  result := (a + b) * (a + b) / (4 * t);

  Form1.Memo1.Text := 'KEXWh Double n = ' + intTostr(n);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
const
  PREC = 15000;
  MPRC = 3;
var
  pai: double;
  pai_big : BigDecimal;
  s, ch : integer;
  pai_mpf : mp_float;
  pcsBack : integer;
begin
  val(labelededit1.Text, s, ch);
  if ch <> 0 then begin
    memo1.Text := 'x̒lɊԈႢ܂';
    exit;
  end;
  if (s < MPRC) or (s > PREC) then begin
    memo1.Text := 'x̒l' + intTostr(MPRC) + 'ȏ' +  intTostr(PREC) + 'ȉɂĂB';
    exit;
  end;
  memo1.Width := 820;                     // s100\ɐݒ
  memo1.Font.Size := 11;                  // s100\ɃtHgTCYݒ
  memo1.Clear;
  pai := pi_calc;                         // double KEXWh̃ASY
  memo1.Lines.Append(floatTostr(pai));
  s := s + 1;                             // 3._ȉ̗L
  pai_big := pi_big(s);                   // BigDecimal KEXWh̃ASY
  pai_big := BigDecimal(pai_big).RemoveTrailingZeros(0);  // ̃[
  memo1.Lines.Append(pai_big.ToString);

  pai_big := big_pi(s);                   // BigDecimal  T.Ooura AGM ASY
  pai_big := BigDecimal(pai_big).RemoveTrailingZeros(0);  // ̃[
  memo1.Lines.Append(pai_big.ToString);

  pcsBack := mpf_get_default_prec;              // ZZxobNAbv
  mpf_set_default_decprec(s);
  mpf_init(pai_mpf);
  pi_mpf(s, pai_mpf);                     // mp_arith  T.Ooura AGM ASY
  memo1.Lines.Append(string(mpf_adecimal_alt(pai_mpf, s)));
  mpf_clear(pai_mpf);
  mpf_set_default_prec(pcsBack);                // Zx̕A
end;

end.
